;EasyCodeName=BmpButton,1
.Const

.Data?

.Data

hInst		HINSTANCE	NULL

hBmpDown	HBITMAP		NULL
hBmpUp		HBITMAP		NULL


.Code

start:
	Invoke GetModuleHandle, NULL
	Mov hInst, Eax
	Invoke GetCommandLine
	Invoke WinMain, hInst, NULL, Eax, SW_SHOWDEFAULT
	Invoke ExitProcess, Eax

WinMain Proc Private hInstance:HINSTANCE, hPrevInst:HINSTANCE, lpCmdLine:LPSTR, nCmdShow:DWord
	Local msg:MSG, wc:WNDCLASSEX
	Local icc:INITCOMMONCONTROLSEX

	;Remove this lines, and their corresponding comctl32.inc and comctl32.lib
	;from project explorer, only if you are not going to use common controls.
	Mov icc.dwSize, SizeOf INITCOMMONCONTROLSEX
	Mov icc.dwICC, 03FFFH ;(ICC_WIN95_CLASSES or ICC_DATE_CLASSES or ICC_USEREX_CLASSES or ICC_COOL_CLASSES or ICC_INTERNET_CLASSES or ICC_PAGESCROLLER_CLASS or ICC_NATIVEFNTCTL_CLASS)
	Invoke InitCommonControlsEx, Addr icc

	;Load bitmap images for buton up/down
	Invoke LoadImage, hInst, IDB_BTN_DOWN, IMAGE_BITMAP, 0, 0, (LR_DEFAULTSIZE Or LR_LOADMAP3DCOLORS Or LR_SHARED)
	Mov hBmpDown, Eax
	Invoke LoadImage, hInst, IDB_BTN_UP, IMAGE_BITMAP, 0, 0, (LR_DEFAULTSIZE Or LR_LOADMAP3DCOLORS Or LR_SHARED)
	Mov hBmpUp, Eax

	Text szClassName, "EasyCodeMainWindow"
	Mov wc.cbSize, SizeOf WNDCLASSEX
	Mov wc.style, CS_DBLCLKS
	Mov wc.lpfnWndProc, Offset WindowProcedure
	Mov wc.cbClsExtra, 0
	Mov wc.cbWndExtra, 0
	Push hInstance
	Pop wc.hInstance
	Mov wc.hIcon, NULL
	Invoke LoadImage, NULL, OCR_NORMAL, IMAGE_CURSOR, 0, 0, (LR_DEFAULTSIZE Or LR_LOADMAP3DCOLORS Or LR_SHARED)
	Mov wc.hCursor, Eax
	Mov wc.hbrBackground, (COLOR_BTNFACE + 1)
	Mov wc.lpszMenuName, NULL
	Mov wc.lpszClassName, Offset szClassName
	Mov wc.hIconSm, NULL
	Invoke RegisterClassEx, Addr wc
	Invoke CreateWindowEx, 0, Addr szClassName, NULL, WS_OVERLAPPEDWINDOW,
						CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
						CW_USEDEFAULT, NULL, NULL, hInst, NULL
	Push Eax
	Invoke ShowWindow, Eax, nCmdShow
	Pop Eax
	Invoke UpdateWindow, Eax

@@:	Invoke GetMessage, Addr msg, NULL, 0, 0
	Cmp Eax, 0
	Jle @F
	Invoke TranslateMessage, Addr msg
	Invoke DispatchMessage, Addr msg
	Jmp Short @B
@@:	Mov Eax, msg.wParam
	Ret
WinMain EndP

WindowProcedure Proc Private Uses Ebx Edi Esi hWnd:HWND, uMsg:ULONG, wParam:WPARAM, lParam:LPARAM
	Local rc:RECT

	.If uMsg == WM_CREATE
		;Get the window client area in
		;order to center the button
		Invoke GetClientRect, hWnd, Addr rc
		Shr rc.right, 1
		Shr rc.bottom, 1
		Sub rc.right, (113 / 2)
		Sub rc.bottom, (113 / 2)

		;Create the button
		Invoke CreateWindowEx, 0, TextAddr("BUTTON"), NULL, (WS_VISIBLE Or WS_CHILD Or WS_CLIPCHILDREN \
							   Or BS_PUSHBUTTON Or BS_BITMAP), rc.right, rc.bottom, 113, 113, hWnd, NULL,
							   hInst, NULL
		;Save the button handle in Edi
		Mov Edi, Eax

		Invoke SendMessage, Edi, BM_SETIMAGE, IMAGE_BITMAP, hBmpUp

		;Get the default window
		;procedure for the button
		Invoke GetWindowLong, Edi, GWL_WNDPROC

		;Save it in the "User data" value
		Invoke SetWindowLong, Edi, GWL_USERDATA, Eax

		;Set a new procedure
		;for the button
		Invoke SetWindowLong, Edi, GWL_WNDPROC, Addr ButtonWndProc

		Xor Eax, Eax
		Ret
	.ElseIf uMsg == WM_DESTROY
		;Delete bitmaps for button up/down
		Invoke DeleteObject, hBmpDown
		Invoke DeleteObject, hBmpUp
		Invoke PostQuitMessage, 0
		Xor Eax, Eax
		Ret
	.EndIf
	Invoke DefWindowProc, hWnd, uMsg, wParam, lParam
	Ret
WindowProcedure Endp

ButtonWndProc Proc Uses Ebx Edi Esi hWnd:HWND, uMsg:ULONG, wParam:WPARAM, lParam:LPARAM
	.If uMsg == WM_LBUTTONDOWN
		;Set the image for pressed button
		Invoke SendMessage, hWnd, BM_SETIMAGE, IMAGE_BITMAP, hBmpDown
	.ElseIf uMsg == WM_LBUTTONUP
		;Set the image for released button
		Invoke SendMessage, hWnd, BM_SETIMAGE, IMAGE_BITMAP, hBmpUp
	.EndIf
	;Call the default button procedure
	Invoke GetWindowLong, hWnd, GWL_USERDATA
	Invoke CallWindowProc, Eax, hWnd, uMsg, wParam, lParam
	Ret
ButtonWndProc EndP

End start
